package com.ims.eval.schedule;

import com.ims.eval.entity.EvaluationWarningRule;
import com.ims.eval.service.IEvaluateRuleInfoService;
import com.ims.eval.service.IEvaluationWarningRuleService;
import com.ims.eval.service.IOrganizationEvaluationService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 考评预警定时处理
 */
@Slf4j
@Component
public class EvaluationWarningSchedule {

	@Autowired
	private IEvaluationWarningRuleService warningRuleService;
	@Autowired
	private IEvaluateRuleInfoService warningInfoService;
	@Autowired
	private IOrganizationEvaluationService evaluationService;


	private final String TYPE_NDKP = "NDKP";
	private final String TYPE_JDKP = "JDKP";
	private final String TYPE_YDKP = "YDKP";


	/**
	 * 年度考评
	 */
	public void warningRuleResolveNDKP(){
		List<EvaluationWarningRule> list = warningRuleService.warningRuleList(null, null, TYPE_NDKP, true);
		List<Map<String, Object>> companys = evaluationService.getCompanyWarning(TYPE_NDKP);

		if (list == null || list.size() == 0 || companys == null || companys.size() == 0) {
			return;
		}


	}

	/**
	 * 季度考评
	 */
	public void warningRuleResolveJDKP(){
		List<EvaluationWarningRule> list = warningRuleService.warningRuleList(null, null, TYPE_JDKP, true);
		if (list == null || list.size() == 0) {
			return;
		}
	}

	/**
	 * 月度考评
	 */
	public void warningRuleResolveYDKP(){
		List<EvaluationWarningRule> list = warningRuleService.warningRuleList(null, null, TYPE_YDKP,true);
		if (list == null || list.size() == 0) {
			return;
		}
	}

	private void calculate(List<EvaluationWarningRule> rules, List<Map<String, Object>> companys){
		Map<Object, List<Map<String, Object>>> collect = companys.stream().collect(Collectors.groupingBy(m -> m.get("indicator_id")));
		for (EvaluationWarningRule rule : rules){
			for (Map.Entry<Object, List<Map<String, Object>>> entry : collect.entrySet()) {
				List<Map<String, Object>> v = entry.getValue();

			}
		}
	}
}
